package cokr.xit.fims.sndb.service.bean;

import java.util.List;

import javax.annotation.Resource;

import org.springframework.stereotype.Component;

import cokr.xit.foundation.AbstractComponent;
import cokr.xit.foundation.data.DataObject;

import cokr.xit.fims.sndb.Sndng;
import cokr.xit.fims.sndb.SndngDtl;
import cokr.xit.fims.sndb.Svbtc;
import cokr.xit.fims.sndb.SndbQuery;
import cokr.xit.fims.sndb.dao.SndngMapper;
import cokr.xit.fims.sndb.dao.SvbtcMapper;

/**발송 대장 정보 관리 Bean
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-08-25	JoJH 최초 작성
 * ================================
 * </pre>
 */
@Component("sndb01Bean")
public class Sndb01Bean extends AbstractComponent {

	/** 발송 대장 정보 DAO */
	@Resource(name = "sndngMapper")
	private SndngMapper sndngMapper;

	/** 공시송달 대장 정보 DAO */
	@Resource(name = "svbtcMapper")
	private SvbtcMapper svbtcMapper;

	/**지정한 조건에 따라 발송 대장 목록을 조회하여 반환한다.
	 * @param req 발송 대장 조회 조건
	 * @return 발송 대장 목록
	 */
	public List<DataObject> getSndngList(SndbQuery req) {
		return sndngMapper.selectSndngList(req);
	}

	/**지정한 조건에 따라 발송 대장 객체들을 반환한다.
	 * @param req 발송 대장 조회 조건
	 * @return 발송 대장 객체 목록
	 */
	public List<DataObject> getSndngs(SndbQuery req) {
		return sndngMapper.selectSndngs(req);
	}

	/**발송 대장 정보를 등록한다.
	 * @param sndng 발송 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean createSndng(Sndng sndng) {
		return sndngMapper.insertSndng(sndng);
	}

	/**발송 대장 정보를 수정한다.
	 * @param sndng 발송 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean updateSndng(Sndng sndng) {
		return sndngMapper.updateSndng(sndng);
	}

	/**발송 대장 정보를 삭제한다.
	 * @param sndng 발송 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean removeSndng(Sndng sndng) {
		return sndngMapper.deleteSndng(sndng);
	}

	/**지정한 조건에 따라 발송 상세 목록을 조회하여 반환한다.
	 * @param req 발송 상세 조회 조건
	 * @return 발송 상세 목록
	 */
	public List<DataObject> getSndngDtlList(SndbQuery req) {
		return sndngMapper.selectSndngDtlList(req);
	}

	/**지정한 조건에 따라 발송 상세 객체들을 반환한다.
	 * @param req 발송 상세 조회 조건
	 * @return 발송 상세 객체 목록
	 */
	public List<DataObject> getSndngDtls(SndbQuery req) {
		return sndngMapper.selectSndngDtls(req);
	}

	/**발송 상세 정보를 등록한다.
	 * @param sndngDtl 발송 상세
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean createSndngDtl(SndngDtl sndngDtl) {
		return sndngMapper.insertSndngDtl(sndngDtl);
	}

	/**발송 상세 정보를 수정한다.
	 * @param sndngDtl 발송 상세
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean updateSndngDtl(SndngDtl sndngDtl) {
		return sndngMapper.updateSndngDtl(sndngDtl);
	}

	/**발송 상세 정보를 삭제한다.
	 * @param sndngDtl 발송 상세
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean removeSndngDtl(SndngDtl sndngDtl) {
		return sndngMapper.deleteSndngDtl(sndngDtl);
	}

	/**지정한 조건에 따라 공시송달 대장 목록을 조회하여 반환한다.
	 * @param req 공시송달 대장 조회 조건
	 * @return 공시송달 대장 목록
	 */
	public List<DataObject> getSvbtcList(SndbQuery req) {
		return svbtcMapper.selectSvbtcList(req);
	}

	/**지정한 조건에 따라 공시송달 대장 객체들을 반환한다.
	 * @param req 공시송달 대장 조회 조건
	 * @return 공시송달 대장 객체 목록
	 */
	public List<DataObject> getSvbtcs(SndbQuery req) {
		return svbtcMapper.selectSvbtcs(req);
	}

	/**공시송달 대장 정보를 등록한다.
	 * @param svbtc 공시송달 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean createSvbtc(Svbtc svbtc) {
		return svbtcMapper.insert(svbtc);
	}

	/**공시송달 대장 정보를 수정한다.
	 * @param svbtc 공시송달 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean updateSvbtc(Svbtc svbtc) {
		return svbtcMapper.update(svbtc);
	}

	/**공시송달 대장 정보를 삭제한다.
	 * @param svbtc 공시송달 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean removeSvbtc(Svbtc svbtc) {
		return svbtcMapper.delete(svbtc);
	}

}
